<?php

namespace WebsiteBundle\Entity;

use Bazookas\CommonBundle\Entity\Base\BaseEntity;
use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Validator\Constraints as Assert;

/**
 * @ORM\Entity
 * @ORM\HasLifecycleCallbacks
 */
class MoodQuestion extends BaseEntity {

  /**
   * @var Experiment
   * @ORM\ManyToOne(targetEntity="Experiment", inversedBy="moodQuestions")
   */
  private $experiment;

  /**
   * @ORM\Column(type="string")
   * @var string
   * @Assert\NotBlank
   */
  private $question;

  /**
   * @ORM\OneToMany(targetEntity="MoodAnswer", mappedBy="question")
   */
  private $answers;

  public function getExperiment()
  {
    return $this->experiment;
  }

  public function setExperiment($experiment)
  {
    $this->experiment = $experiment;

    return $this;
  }

  public function getQuestion()
  {
    return $this->question;
  }

  public function setQuestion($question)
  {
    $this->question = $question;

    return $this;
  }

  public function getAnswers()
  {
    return $this->answers;
  }

  public function setAnswers($answers)
  {
    $this->answers = $answers;

    return $this;
  }

}
