var bazookas = bazookas || {};

bazookas.moodQuestions = (function () {
  var self = {},
    language,
    now;

  var $score = $('.question__score');
  var answers = [];
  var url = $('#mood_questions').data('url');

  self.init = function (context) {
    $score.on('click', questionSelectedHandler);
    $('#sendMoodQuestion').on('click', sendMoodQuestionClickHandler);
  };

  function questionSelectedHandler(e){
    var $target = $(e.currentTarget) ;
    var rating = $target.data('rating');
    var question = $target.parent().data('question');

    $target.parent().find('.selected').removeClass('selected');
    $target.toggleClass('selected');
    var found = false;

    for(var i = 0; i < answers.length; i ++){
      if(answers[i].questionId == question){
        found = true;
        answers[i].answer = rating;
      }
    }
    if(!found){
      answers.push({
        questionId: question,
        answer: rating
      })
    }
  }

  function sendMoodQuestionClickHandler(e){
    var reminderUrl = $(e.target).data('reminder-url');

    var comment = $('#extraComment').val();
    var data  = {
      data: answers
    };

    if (comment) {
      data.comment = comment;
    }

    $.ajax({
      method: "POST",
      url: url,
      data: JSON.stringify(data),
      dataType: "json",
      contentType: "application/json; charset=utf-8",
    })
    .error(function (error) {
      console.error('error', error);
    })
    .done(function() {
      window.location = reminderUrl;
    })
    ;
  }

  return self;
})();

