<?php

namespace Bazookas\AdminBundle\AdminElements\Containers;

use Bazookas\AdminBundle\AdminElements\Base\BaseAdminElement;

class CollapsibleContainer extends BaseAdminElement
{

  protected function getDefaultOptions() {
    $defaults = parent::getDefaultOptions();
    return array_merge($defaults, [
      'template' => 'BazookasAdminBundle:AdminElements/Containers:collapsibleContainer.html.twig',
      'initiallyCollapsed' => true,
      'class' => 'collapse',
      'id' => ''
    ]);
  }

  public function getInitiallyCollapsed() {
    return $this->options['initiallyCollapsed'];
  }

  public function setInitiallyCollapsed($bool) {
    $this->options['initiallyCollapsed'] = $bool;
    return $this;
  }

  public function getId() {
    return $this->options['id'];
  }

  public function setId($id) {
    $this->options['id'] = $id;
    return $this;
  }

  public function getClass()
  {
    // append the "in" class when not initially collapsed
    return parent::getClass() . ($this->options['initiallyCollapsed'] ? '' : ' in');
  }

}
