<?php

namespace Bazookas\AdminBundle\AdminElements\Containers;

use Bazookas\AdminBundle\AdminElements\Elements\Actions\Base\BaseActionElement;
use Bazookas\AdminBundle\AdminElements\Elements\Actions\Base\BulkActionElement;
use Bazookas\AdminBundle\AdminElements\Elements\Actions\Base\RowActionElement;
use Bazookas\AdminBundle\Controller\Base\BaseAdminActionController;

class ListTableContainer extends TableContainer {

  protected $actions = [];

  protected $fields = [];

  protected $hasRowActions = false;

  protected $hasBulkActions = false;

  protected $rowActionCount = 0;

  protected $bulkActionCount = 0;

  protected $pageCount = 1;

  protected $currentPage = 0;

  protected function getDefaultOptions() {
    $defaults = parent::getDefaultOptions();
    return array_merge($defaults, [
      'template' => 'BazookasAdminBundle:AdminElements/Containers:listTableContainer.html.twig',
      'class' => '',
      'ajaxPageable' => false,
      'pageAction' => BaseAdminActionController::ACTION_LIST,
      'inlineEditable' => false
    ]);
  }

  public function getActions() {
    return $this->actions;
  }

  public function getAjaxPageable() {
    return $this->options['ajaxPageable'];
  }

  public function getPageAction() {
    return $this->options['pageAction'];
  }

  public function getInlineEditable() {
    return $this->options['inlineEditable'];
  }

  /**
   * @param BaseActionElement[] $actions
   * @return $this
   */
  public function setActions(array $actions) {
    $this->actions = $actions;

    foreach($actions as $action) {
      if ($action instanceof RowActionElement) {
        $this->hasRowActions = true;
        $this->rowActionCount++;
      }

      if ($action instanceof BulkActionElement) {
        $this->hasBulkActions = true;
        $this->bulkActionCount++;
      }
    }

    return $this;
  }

  public function getFields()
  {
    return $this->fields;
  }

  /**
   * @param array $fields
   * @return $this
   */
  public function setFields(array $fields)
  {
    $this->fields = $fields;
    return $this;
  }

  public function getTableHeading() {
    if (empty($this->tableHeading)) {
      foreach($this->fields as $field) {
        $this->tableHeading[] = $field->getLabel();
      }
    }

    return $this->tableHeading;
  }

  public function hasRowActions() {
    return $this->hasRowActions;
  }

  public function hasBulkActions() {
    return $this->hasBulkActions;
  }

  public function getRowActionCount() {
    return $this->rowActionCount;
  }

  public function getBulkActionCount() {
    return $this->bulkActionCount;
  }

  public function getPageCount()
  {
    return $this->pageCount;
  }

  public function setPageCount($pageCount)
  {
    $this->pageCount = $pageCount;

    return $this;
  }

  public function getCurrentPage()
  {
    return $this->currentPage;
  }

  public function setCurrentPage($currentPage)
  {
    $this->currentPage = $currentPage;

    return $this;
  }

}
