<?php

namespace Bazookas\AdminBundle\Entity\Interfaces;

use Bazookas\CommonBundle\Entity\Base\BaseCMSUser;
use Doctrine\Common\Collections\ArrayCollection;

interface Versionable
{

  /**
   * @return string
   */
  public function getEntityId();

  /**
   * @param string $entityId
   * @return string
   */
  public function setEntityId($entityId);

  /**
   * @return $this
   */
  public function getParent();

  /**
   * @param Versionable|null $parent
   * @return $this
   */
  public function setParent(Versionable $parent = null);

  /**
   * @param Versionable[]|ArrayCollection $children
   * @return $this
   */
  public function setChildren($children);

  /**
   * @return ArrayCollection
   */
  public function getChildren();

  /**
   * @param Versionable $child
   * @return $this
   */
  public function addChild(Versionable $child);

  /**
   * @param BaseCMSUser $creator
   * @return $this;
   */
  public function setCreator(BaseCMSUser $creator);

}
