<?php

namespace Bazookas\AdminBundle\Twig;

use Twig_Test;

class UtilExtension extends \Twig_Extension
{
  public function getFilters()
  {
    return [
      new \Twig_SimpleFilter('youtube_thumbnail', [$this, 'getYouTubeThumbnail']),
    ];
  }

  public function getTests()
  {
    return [
      new Twig_Test('instanceof', [ $this, 'isInstanceof']),
    ];
  }

  public function getYouTubeThumbnail($url)
  {
    $youtubeId = substr($url, strpos($url, '?v=') + 3);

    return 'http://img.youtube.com/vi/' . $youtubeId . '/0.jpg';
  }

  public function getName()
  {
    return 'util_extension';
  }

  public function isInstanceof($var, $instance)
  {
    return $var instanceof $instance;
  }
}
