<?php

namespace Bazookas\APIFrameworkBundle\Controller\Admin;

use Bazookas\AdminBundle\Controller\ListBaseController;
use Bazookas\APIFrameworkBundle\Form\AppCopyAdminType;
use Symfony\Component\HttpFoundation\Request;

class AppCopyAdminController extends ListBaseController
{

  function __construct() {
    // make sure parent construct is called!
    parent::__construct();

    $this->config->entityName = 'admin.entities.appCopy.name';
    $this->config->orderBy = 'created';

    $this->config
      ->addBasicField('key', 'admin.entities.appCopy.fields.key')
      ->addBasicField('details', 'admin.entities.appCopy.fields.details', 'BazookasAPIFrameworkBundle:List//Fields:_appCopyDetails.html.twig')
    ;
    $this->config->setForm(AppCopyAdminType::class);

    //enable filtering
    $this->config
      ->setShowFilter(true)
      ->setMaintainFilterState(true)
      ->addBasicTextFilter('key', 'admin.entities.appCopy.fields.key')
      ->addBasicTextFilter('details.value', 'admin.entities.appCopy.fields.details')
    ;
  }

  public function indexAction(Request $request, $_action = null, $_id = null) {
    // because container is not yet accessible in constructor
    $this->config->entity = $this->getParameter('bazookas_api_framework.app_copy.entity');
    return parent::indexAction($request, $_action, $_id);
  }

  protected function checkAccess($_action, $_id) {
    // when returning false on any action, there is no real need to set these
    // these are only usefull for showing/hiding the buttons
    // $this->config->setAccess(self::ACTION_ADD, false);
    // $this->config->setAccess(self::ACTION_EDIT, false);
    // $this->config->setAccess(self::ACTION_REMOVE, false);
    return $this->isGranted('ROLE_SUPER_ADMIN');
  }

}
