<?php
namespace Bazookas\APIFrameworkBundle\Exception;

use Exception;
use Bazookas\APIFrameworkBundle\Exception\Base\BaseApiException;
use Bazookas\APIFrameworkBundle\Exception\Base\ApiExceptionMap;
use Bazookas\CommonBundle\Services\Exception\Interfaces\LoggableExceptionInterface;
use Symfony\Component\HttpFoundation\Response;

class ServiceException extends BaseApiException {

  public function __construct($message, $name = ApiExceptionMap::SERVICE_EXCEPTION, $statusCode = Response::HTTP_INTERNAL_SERVER_ERROR, Exception $previous = null) {
    parent::__construct($message, $name, $statusCode, $previous);
  }

  public function getLoggingSeverity() {
    return LoggableExceptionInterface::PRIORITY_CRITICAL;
  }

  //Overwrite the base implementation for performance reasons
  public function getName() {
    if (!empty($this->name)) {
      return $this->name;
    }

    return 'ServiceException';
  }
}
