## Common configuration examples

- [Convert DateTimes to scalars](#convert-datetimes-to-scalars)

#### Convert DateTimes to scalars

```php
$config = [
  'created' => [
    [
      'transformation' => 'date_format',
      'params' => 'U'
    ],
    [
      'transformation' => [OutputFormatter::class, 'convertToType'],
      'params' => OutputFormatter::TYPE_INTEGER
    ]
  ]
];

```

converts:

 ```json
{
    "created":{
         "date":"2016-12-06 19:07:58.000000",
         "timezone_type":3,
         "timezone":"Europe\/Zurich"
    }
}
 ```

to 

 ```json
{
    "created":1481047820
}
 ```

Note that the type conversion transformation could also have been written as:
```php
$config = [
  'created' => [
    [
      'transformation' => ['intval']
    ]
  ]
];

```
by making use of the built in php function `intval` to do the conversion to integer.
