<?php

namespace Bazookas\CommonBundle\Form;

use Bazookas\CommonBundle\Entity\Base\BaseAppUser;
use Symfony\Component\Form\AbstractType;
use Symfony\Component\Form\Extension\Core\Type\PasswordType;
use Symfony\Component\Form\Extension\Core\Type\RepeatedType;
use Symfony\Component\Form\Extension\Core\Type\SubmitType;
use Symfony\Component\Form\FormBuilderInterface;
use Symfony\Component\OptionsResolver\OptionsResolver;

class BaseAppUserForgotPasswordForm extends AbstractType
{
  /**
   * @param FormBuilderInterface $builder
   * @param array $options
   */
  public function buildForm(FormBuilderInterface $builder, array $options)
  {
    $builder
      ->add('plainPassword', RepeatedType::class, array(
        'type' => PasswordType::class,
        'first_name' => 'first',
        'second_name' => 'second',
        'first_options' => array(
          'label' => 'common.entities.BaseAppUser.fields.password'
        ),
        'second_options' => array(
          'label' => 'common.entities.BaseAppUser.fields.repeatedPassword'
        ),
        'invalid_message' => 'common.entities.BaseAppUser.errors.repeatedPassword'
      ))
      ->add('submit', SubmitType::class, array(
        'label' => 'common.entities.BaseAppUser.buttons.submit',
        'attr' => [
          'class' => 'btn-success'
        ]
      ))
    ;
  }

  /**
   * @param OptionsResolver $resolver
   */
  public function configureOptions(OptionsResolver $resolver)
  {
    $resolver->setDefaults(array(
      'data_class' => BaseAppUser::class,
      'csrf_protection' => true,
      'translation_domain' => 'admin'
    ));
  }
}
