<?php
namespace Bazookas\CommonBundle\Services\Exception\Interfaces;

use Exception;
use Symfony\Component\HttpFoundation\Response;

interface LoggableExceptionInterface {

  const PRIORITY_INFO = 'info';
  const PRIORITY_ERROR = 'error';
  const PRIORITY_CRITICAL = 'critical';

  // Redefine the exception so message isn't optional
  public function __construct($message, $code = 0, $statusCode = Response::HTTP_INTERNAL_SERVER_ERROR, Exception $previous = null);

  // custom string representation of object
  public function __toString();

  public function getName();

  public function isLoggable();

  public function getLoggingSeverity();

}
